﻿// Скрипт проверки возможности размещения рекламных вкладок между тетрадками журнала
// v.1 (Feb 2023) // densen

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Перечень ошибок (нет открытых документов, количество секций меньше или равно 5, нечетное количество страниц)

if (app.documents.length == 0) {alert("Откройте документ и повторите попытку."); exit();}
if (app.activeDocument.sections.length <= 5) { alert ("В документе всего " + app.activeDocument.sections.length + " раздел(ов), поэтому результаты могут быть неверными. Убедитесь, что каждая статья начинается с нового раздела.")};
if (app.activeDocument.pages.length % 2) {alert ("В документе нечетное количество страниц, поэтому результаты могут быть неверными. Проверьте, чтобы в документе было четное количество страниц.")}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Внесение пользовательских данных

myStyle = app.activeDocument.paragraphStyles.itemByName("[Basic Paragraph]"); // Абзацный стиль надписи с результатом, если стиль находится вне групп
//myStyle = app.activeDocument.paragraphStyleGroups.itemByName("Article").paragraphStyles.itemByName("Main Text"); // Абзацный стиль надписи с результатом, если стиль находится в группе
mySign = 8; // Количество страниц в тетрадке

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


var myDoc = app.activeDocument;
var mySecFP = []; // Объявляется массив первых страниц разделов
var mySecLP = []; // Объявляется массив последних страниц разделов
for (i = 0; i < myDoc.sections.length; i++) {
    mySecFP[i] = myDoc.sections[i].pageNumberStart; // Высчитывается каждая первая страница разделов и заносится в массив
    mySecLP[i] = mySecFP[i] + myDoc.sections[i].length - 1; // Высчитывается каждая последняя страница разделов и заносится в массив
};
var myOstatok = myDoc.pages.length % mySign; // Вычисление остатка от деления количества страниц документа на <mySign = 8 или mySign = 16> = количество страниц не-тетрадкой

var myBooklets = (myDoc.pages.length - myOstatok)/mySign; // Количество возможных мест размещения рекламы
var myBookletsLP = [] // Объявляется массив последних страниц тетрадок

if (myOstatok === 0) { // Если от деления количества страниц документа на <mySign = 8 или mySign = 16> нет остатка, то все тетради по <mySign = 8 или mySign = 16> страниц
    myBooklets = myBooklets - 2;
    for (i = 0; i <= myBooklets; i++) {
        myBookletsLP[i] = mySign + i * mySign; // Высчитывается каждая последняя страница тетрадок и заносится в массив
    };
        } else {
        myBooklets = myBooklets - 1;
        myBookletsLP[0] = mySign;
        for (i = 1; i <= myBooklets; i++) {
        myBookletsLP[i] = myBookletsLP[0]  + myOstatok + (i-1) * mySign; // Высчитывается каждая последняя страница тетрадок и заносится в массив
    };
};
myBooklets = myBooklets + 1;
var myPages = []; // Объявляется массив страниц, после которых будет размещена реклама
for (var i = 0; i < mySecLP.length; i++) { // Проходимся по первому масcиву
    for (var j = 0; j < myBookletsLP.length; j++) { // Ищем соответствия во втором массиве
        if (mySecLP[i] === myBookletsLP[j]){ // Если возникает совпадение значений между двумя архивами...
        myPages.push(mySecLP[i]); // ...то это значение вносится в массив страниц, после которых возможно размещение рекламной вкладки
        };
    };
};

myDoc.pages[0].select(); // Перемещение фокуса на первую страницу документа
app.layoutWindows[0].zoomPercentage = 81; // Fit To Page
var textFrame = myDoc.spreads[0].textFrames.add // Добавление текстового фрейма (размеры, обводка, заливка, текст с результатом
( 
    { 
        geometricBounds: [70,-135,90,-15], 
        strokeWidth: 0, 
        fillColor: "None", 
        contents: "Рекламную вкладку возможно разместить" + "\rпосле следующих страниц: " + myPages.join(", ")
    } 
);
textFrame.parentStory.texts[0].appliedParagraphStyle = myStyle; // Абзацный стиль текста с результатом
textFrame.parentStory.texts[0].pointSize = 16; // Размер текста с результатом